
<!-- December 2023. Added documentation. 
About the page: This walkthrough uses three.js to render a 3d terrain map of DD hills along with an overlay of 3d scans and 360 panoramas of objects in the hills. 
Users can navigate to a fixed number of spots on the map and look around. I some spots there are sweets that are tagged to that specific location. 
Users can expand the sweets to fill the screen (click spacebar) and double click a sweet cloud to open it up.

The code below contains the following:
1.HTML elements and script for loading screen, navbar, pano close and sweets overlay
2. Scripts to fetch sweets from swtstore and display them
3. Three.js code to render the scene, load 3d terrain map, 3d objects, panos and sweets, event handlers for keyboard and mouse, skybox (cloud texture that covers the entire scene.)
4. 3d coordinates of the various places on the navbar, the coordinates of the 3d objects and panos have been derived from real world lat,long. The script for this is not in this file-->
<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title>AntHillHacks</title>
    <!-- Bootstrap to fetch sweets -->
    <link rel="stylesheet" href="css/bootstrap/css/bootstrap.css">
    <!-- Lightbox for sky -->
    <link rel="stylesheet" href="css/lightbox.css">
  
    <!-- CSS -->
    <style>
    html,
    body {
        width: 100%;
        height: 100%;
    }
    
    body {
        background-color: #ffffff;
        margin: 0;
        overflow: hidden;
        font-family: arial;
    }
    
    #swt-container {
        margin-top: 40px;
        display: none;
        height: 100vh;
        position: fixed;
        overflow-y: auto;
        overflow-x: hidden;
        z-index: 100;
        transition: all .4s ease 0s;
        /*background: #fff;*/
    }
    
    #swt-overlay {
        z-index: 100;
        display: none;
    }
    
    #swt-overlay.active #swt-container {
        /*top: 75vh;*/
        display: block;
    }
    
    .img-thumbnail {
        width: 300px;
        height: 200px;
    }
    
    .panel-footer {
        height: 200px;
        overflow: hidden;
    }
    
    #loading-screen {
        position: absolute;
        width: 100%;
        height: 100%;
        background-color: #f05f40;
        z-index: 100;
    }
    
    #loading-text {
        left: 50%;
        text-align: center;
        color: white;
        cursor: pointer;
        font-size: 40px;
    }
    
    #help {
        z-index: 150;
        position: absolute;
        top: 90%;
        left: 93%;
    }
    
    #myModal.modal-dialog {
        width: 100%;
    }
    
    #panoButton{
	z-index: 150;
        position: absolute;
        top: 5%;
        left: 93%;
	display: none;
    }
    </style>
</head>

<body>

    <!-- Scripts -->
    <script src="js/three_r73.js"></script>
    <script src="js/OrbitControls.js"></script>
    <script src="js/Projector.js"></script>
    <script src="js/Detector.js"></script>
    <script src="js/FontUtils.js"></script>
    <script src="js/TextGeometry.js"></script>
    <script src="js/fonts/helvetiker_regular.typeface.js"></script>
    <script src="js/fonts/helvetiker_bold.typeface.js"></script>
    <script src="js/fonts/gentilis_regular.typeface.js"></script>
    <script src="js/fonts/optimer_bold.typeface.js"></script>
    <script src="js/fonts/optimer_regular.typeface.js"></script>
    <script src="js/jquery-1.11.3.min.js"></script>
    <script src="js/underscore-min.js"></script>
    <script src="js/backbone-min.js"></script>
    <script src="js/threex.domevents.js"></script>
    <script src="js/threex.linkify.js"></script>
    <script src="js/tween.min.js"></script>
    <script src="css/bootstrap/js/bootstrap.js"></script>
    <script src="js/lightbox.js"></script>
    
    <!-- Loading Screen Code -->
    <div id='loading-screen'>
        <div style="background-color: white;">
            <center>
                <img src='images/controls2.jpg'></img>
            </center>
            <br>
        </div>
        <div id='loading-text'>
            <span style="font-size:40px">LOADING </span>
            <br />
            <div id='stat'>
                <center> 10%</center>
            </div>
        </div>
    </div>

    <script>
    if (!Detector.webgl) {
        Detector.addGetWebGLMessage();
        document.getElementById('loading-screen').innerHTML = "<h1  style='color:white' >Oops! Looks like your browser doesn't support WebGL. Learn more <a href='https://get.webgl.org/'>here.</a></h1>";

    }
    </script>

    <div id='help'>
        <!-- Button trigger modal -->
        <button type="button" class="btn btn-primary btn-lg" data-toggle="modal" data-target="#myModal">
            Help?
        </button>
    </div>
    
    <!-- pano close button -->
    <div id='panoButton'>
    <button type='button' class="close" id="panoClose" >
	<span aria-hidden="true" style='font-size:50px' >&times;</span>
	</button>
	</div>

	<script>
    $('#panoClose').click(function(){
	if (panoFlag == true) {
		//console.log(tempPosition);
		//camera.position.set(tempPosition.x, tempPosition.y, tempPosition.z);
		//controls.center.set(tempPosition.x-1, tempPosition.y, tempPosition.z);
		//tempPosition = new THREE.Vector3();
		panoFlag = false;
		pano.visible = false;
		idol_mesh.visible= true;
		     terrain_map.visible= true;
		     drone_mesh.visible= true;
		     document.getElementById('panoButton').style.display = 'none';
		     document.getElementById('nav-bar').style.display = 'block';
		//pano.material.needsUpdate = true;
	}
    });
    </script>
    
    <!-- Modal -->
    <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title" id="myModalLabel">Having trouble navigating?</h4>
                </div>
                <div class="modal-body">
                    <h4>Use the Nav-bar on top to change locations.</h4>
                    <br>
                    <h4>Double-click on a comment cloud to explore it.</h4>
                    <br>
                    <img src='images/controls2.jpg'></img>
                </div>
            </div>
        </div>
    </div>

    <!-- Navbar -->
    <div class="btn-group-xs" id='nav-bar' role="group">
        <span class="label label-default">Navigation</span>
    </div>

    <!-- Script to populate Navbar -->
    <script>
    var AntHillHacksTags = ["Anterras", "Tent1", "Tent2", "TB", "YatriNivas", "Yoga", "Bhoga", "JeebeeAmma", "Kalyani", "Durgadahalli", "Halekote"];
    for (i = 0; i < AntHillHacksTags.length; i++) {
        $("#nav-bar").append("<button type=\"button\" class=\"btn btn-default btn-xs\" href=\"#\" id=\"" + AntHillHacksTags[i] + "\">" + (i + 1) + "." + AntHillHacksTags[i] + "</button>");
    }
    </script>

    <!-- Sweets Overlay -->
    <div class="" id="swt-overlay">
        <div class="container" id="swt-container"></div>
        <a type="button" class="btn btn-default pull-right" id="close-swt">
            <span class="glyphicon glyphicon-remove"></span>
        </a>
    </div>

    <!-- Templates for web components for sweets -->
    <script type="text/template" id="swts-template">
        <div class="col-md-4 col-lg-3 ">
            <div class="panel panel-default">
                <div class="panel-body">
                    <% if(what == "img-anno") {%>
                        <div class="media">
                            <a class="lightbox-item" href="<%=where%>" data-lightbox="<%=what%>" data-title="<%=how.comment%> <%=how.tags%>">
                                <img class="media-object img-thumbnail" src="<%=where%>"  />
                            </a>
                        </div>
                        <div class="panel-footer">
                            <h4 class="panel-heading"> <%=how.title%></h4>
                            <h5> <%=how.comment%></h5>
                            <p>-
                                <%=who%> tagged
                                    <%=how.tags%> on
                                        <%var d = new Date(created), locale = "en-us",fragments = [d.toLocaleString(locale, { month: "long" }), d.getDate(), d.getFullYear()]; print(fragments[0]+' '+fragments[1]+','+' '+fragments[2]);%>
                            </p>
                        </div>
                        <%}%>
                            <%if ( what == "audio-tagger") {%>
                                <audio controls="controls" preload="none">
                                    Your browser does not support the <code>audio</code> element.
                                    <source src="<%=where%>"> >
                                    <div class="panel-footer">
                                        <p>-
                                            <%=who%> tagged
                                                <%=how.tags%> on </p>
                                        <%var d = new Date(created), locale = "en-us", fragments = [d.toLocaleString(locale, { month: "long" }), d.getDate(), d.getFullYear()]; print(fragments[0]+' '+fragments[1]+','+' '+fragments[2]);%>
                                    </div>
                                    <%}%>
                </div>
            </div>
        </div>
    </script>

    <script>
    //webView Top panel slider
    $("#close-swt").click(function(e) {
        e.preventDefault();
        $("#swt-overlay").toggleClass("active");

    });

    // Swts from swt store
    var swt = Backbone.Model.extend({
        defaults: {
            'who': '',
            'what': '',
            'where': '',
            'how': {}
        }
    });


    var swtsCollection = Backbone.Collection.extend({
        model: swt,
        filterByTag: function(tag) {
            var swts = this.filter(function(model) {
                if (_.contains(model.get('how').tags, tag)) {
                    return model;
                }
            });
            return swts = _.uniq(swts, function(swt) {
                return swt.get('where');
            });
        }
    });
    var txtAnno = new swtsCollection();
    txtAnno.fetch({
        url: 'https://thestore.swtr.in/api/sweets/q?what=txt-anno'
    });
    var audioAnno = new swtsCollection();
    audioAnno.fetch({
        url: 'https://thestore.swtr.in/api/sweets/q?what=audio-tagger'
    });
    swts = new swtsCollection();
    swts.fetch({
        url: 'https://thestore.swtr.in/api/sweets/q?what=img-anno',
        success: function(swts, response) {
            swts.add(txtAnno.models);
            swts.add(audioAnno.models);
            init();
            animate();
        }
    });
    console.log(swts);

    //swts view to handle click handlers
    var swtsView = Backbone.View.extend({
        el: "#swt-overlay",
        events: {
            "click #close-swt": "toggle"
        },
        setCustomField: false,
        initialize: function(options) {
            //_.bindAll.apply(_, [this].concat(_.functions(this)));
            //this.bind('cleanUp', 'click', this.cleanUp);
            this.$swtContainer = $("#swt-container");
            this.render();
        },
        template: _.template($('#swts-template').html()),
        render: function() {
            this.$swtContainer.html('');
            //this.targetId = this.collection.get(options.id);
            _.each(this.collection, function(model) {
                this.$swtContainer.append(this.template(model.toJSON()));
            }, this);
            this.toggle();
            this.initAnno();
        },
        initAnno: function() {
            if (!this.setCustomField) {
                anno.addPlugin("CustomFields", {});
                this.setCustomField = true;
            }
            _.each($("img"), function(item) {
                anno.makeAnnotatable(item);
            });
            _.each(this.collection, function(swt) {
                    var anno_obj = swt.toJSON();
                    var newAnno = {};
                    newAnno.editable = false,
                        newAnno.id = anno_obj.id,
                        newAnno.shapes = anno_obj.how.shapes,
                        newAnno.src = anno_obj.how.src,
                        newAnno.context = anno_obj.how.context,
                        newAnno.text = anno_obj.how.comment;
                    console.log(anno_obj, newAnno);
                    anno.addAnnotation(newAnno);
                    anno.hideSelectionWidget();
                },
                this);
            console.log("annotatable");
        },
        toggle: function() {
            console.log("toggle");
            if (this.$el.is(":hidden")) {
                this.$el.show();
                this.$el.toggleClass("active");
            } else {
                this.$el.hide();
                this.undelegateEvents();
            }
        },
        cleanUp: function() {
            this.remove();
        }
    });
    </script>

        
    <!-- Onclick Function. These are the 3d coordinates of places to navigate to in the walkthrough -->
   <script type="text/javascript">
    var AntHill = new Array;
    //Factored by dinesh
    AntHill['Anterras'] = [6800, -800.5, 250];
    AntHill['Durgadahalli'] = [9620, -2877, 14633];
    AntHill['Halekote'] = [7854, -2790, 9307];
    AntHill['Yoga'] = [303, 1531, 6534];
    AntHill['Bhoga'] = [5241, -496, 1936];
    AntHill['JeebeeAmma'] = [4089, -771, 370.5];
    AntHill['Kalyani'] = [6939 / 2, -1091, -454];
    AntHill['Tent1'] = [6550, -801, 669];
    AntHill['Tent2'] = [6520, -808, 125.5];
    AntHill['TB'] = [5867, -260, 3318];
    AntHill['YatriNivas'] = [6542, -800, 700];

    //$('#Anterras').click(function(){
    _.each(AntHillHacksTags, function(t) {
        $('#' + t).on('click', function(e) {
            var p = AntHill[t];
            camera.position.set(p[0] - 100, p[1], p[2]);
            controls.center.set(p[0] - 99, p[1], p[2]);
            // Insert line for camera.lookat.p
            $(e.currentTarget).blur();
        });

    });
    </script>
   
   <!-- Walkthrough code. This section operates the walkthrough. 
    It uese Three.js - a 3d library to in which the terrain map of devarayanadurga hills is loaded. 
    A camera is added to view the scene. 
    The menu bar at the top of the screen allows users to move the camera to the desiread location. 
    Users can look around the world using a mouse or trackpad. Double clicking sweets or 360 panos open them up.-->

    <script>
    //variables 
    var camera, scene, renderer;
    var controls, controls2;
    var objects = [];
    var raycaster, raycaster2, mouse;
    var murra, cube, cube2, camera2;
    var raycaster2 = new THREE.Raycaster();
    var direction = new THREE.Vector3(0, 0, 0.5);
    var rotation = new THREE.Euler(0, 0, 0, "YXZ");
    var v3 = new THREE.Vector3;
    var info_tex, info_geo, info_mat, info_icon;
    var audio_tex, audio_geo, audio_mat, audio_icon, terrain_map;
    var colorize = 0,
        ji = 0;
    var mClick = 0;
    var sweet = [],
        sweet_geo = [],
        sweet_mat = [],
        canvas = [],
        context = [],
        img2 = [],
        texture12 = [],
        who = [],
        what = [],
        where = [],
        id = [],
        created = [],
        title = [],
        tags = [],
        temp = [],
        comment = [];
    var intersects2;
    var intersections2;
    var mesh, mesh2;
    var filteredsweet = [];
    var group1, group2;
    var domEvents;
    var sweetFlag = false;
    var manager;
    var panos = [];
    //The four 360 panorama photos. 
    panos[0] = new THREE.ImageUtils.loadTexture('images/panoramas/bathery.jpg');
    panos[1] = new THREE.ImageUtils.loadTexture('images/panoramas/front.jpg');
    panos[2] = new THREE.ImageUtils.loadTexture('images/panoramas/top.jpg');
    panos[3] = new THREE.ImageUtils.loadTexture('images/panoramas/temple.jpg');
    var marker = ['batheryMarker', 'frontMarker', 'topMarker', 'templeMarker'];
    var markers = new Array;
    markers['batheryMarker']= [ 6550,  -800.5, 50];
    markers['frontMarker']= [5860,  -320.5,  3280];
    markers['topMarker']= [ 5900,  -280.5, 3340];
    markers['templeMarker']= [283,  1221,  6474];
    var markerMesh = [];
    var skybox;
    var tempPosition = new THREE.Vector3();
    var panoFlag;
    var pano;
    var AntHillHacksTags = ["Anterras", "Tent1", "Tent2", "TB", "YatriNivas", "Yoga", "Bhoga", "JeebeeAmma", "Kalyani", "Durgadahalli", "Halekote"];
    </script>
    
    <!-- Loading Manager -->
    <script>
    manager = new THREE.LoadingManager();

    manager.onProgress = function(item, loaded, total) {

        if (loaded == 1) {
            document.getElementById('stat').innerHTML = '40%';
            console.log(loaded);
        } else if (loaded == 2) {
            document.getElementById('stat').innerHTML = '70%';
            console.log(loaded);
        } else if (loaded == 3) {
            document.getElementById('stat').innerHTML = '100%';
            console.log(loaded);
        }

    };
    manager.onLoad = function() {
        console.log('all items loaded');
        document.getElementById('loading-screen').style.display = 'none';
	//makePanos();
    };
    manager.onError = function() {
        console.log('there has been an error');
    };
    </script>

    <!-- Init Function -->
    <script>
    function init() {

        renderer = new THREE.WebGLRenderer({
            antialias: true
        });
        renderer.setClearColor(0x333377, 0.9);
        renderer.autoClear = false;
        renderer.setSize(window.innerWidth, window.innerHeight);
        document.body.appendChild(renderer.domElement);

        scene = new THREE.Scene();
        camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 1, 91000);
        scene.add(camera);
        camera.position.set(6408, 221, 576)

        //controls
        controls = new THREE.OrbitControls(camera, renderer.domElement);
        controls.noPan = true;
        controls.noZoom = true;
        controls.center.set(camera.position.x - 0.1, camera.position.y, camera.position.z);


        //dom events
        domEvents = new THREEx.DomEvents(camera, renderer.domElement);
        document.addEventListener('keydown', onKeyDown, false);
        document.addEventListener('mousewheel', onDocumentMouseWheel, false);
        window.addEventListener('resize', onWindowResize, false);
        raycaster = new THREE.Raycaster(new THREE.Vector3(), new THREE.Vector3(0, -1, 0), 0, 1000);
        mouse = new THREE.Vector2();


        //objects
    var loader3 = new THREE.JSONLoader(manager);
        tex4 = new THREE.ImageUtils.loadTexture('objects/idol/meshAvImgCol_color.png');
        loader3.load("objects/idol/idolsimple.js", function(geometry, material) {
            geometry.center();
            var scale = 10;
            idol_mesh = new THREE.Mesh(geometry, new THREE.MeshBasicMaterial({
                map: tex4,
                side: THREE.DoubleSide
            }));
            idol_mesh.rotation.set(-3.0999, 1.4999, 0);
            idol_mesh.scale.set(scale, scale, scale);
            scene.add(idol_mesh);
            idol_mesh.position.set(3375.4281241, -1160, -331.91);
        });
        var loader = new THREE.JSONLoader(manager);
        tex2 = new THREE.ImageUtils.loadTexture('objects/tb_drone2/meshAvImgCol_color.png');
        loader.load("objects/tb_drone2/itbdron3.1.js", function(geometry, material) {
            geometry.center();
            var scale = 5;
            drone_mesh = new THREE.Mesh(geometry, new THREE.MeshBasicMaterial({
                map: tex2,
                side: THREE.DoubleSide
            }));
            drone_mesh.rotation.set(3.1, -3.90, 0);
            drone_mesh.scale.set(scale, scale, scale);
            scene.add(drone_mesh);
            drone_mesh.position.set(5909, -355, 3293);
        });

        var loader4 = new THREE.JSONLoader(manager);
        var tex5 = new THREE.ImageUtils.loadTexture('objects/ddhills_terrain_3/0_test1_0_3.jpg');
        tex5.generateMipmaps = false;
        tex5.minFilter = THREE.LinearFilter;
        tex5.magFilter = THREE.LinearFilter;
        loader4.load("objects/ddhills_terrain_3/0_test1_4.js", function(geometry, material) {
            geometry.center();
            var scale = 100;
            terrain_map = new THREE.Mesh(geometry, new THREE.MeshBasicMaterial({
                map: tex5,
                side: THREE.DoubleSide
            }));
            terrain_map.scale.set(scale, scale, scale);
            scene.add(terrain_map);
            terrain_map.position.set(0, -1360, 0);

            //threex event handler
            domEvents.addEventListener(terrain_map, 'click', function(event) {
                console.log("eh?");
            }, false);
        });


        //skybox
        skybox = new THREE.Mesh(new THREE.SphereGeometry(40000, 70, 70), new THREE.MeshBasicMaterial({
            map: new THREE.ImageUtils.loadTexture('images/sky1.jpg'),
            side: THREE.BackSide
        }));
        scene.add(skybox);
        skybox.position.set(0, -4360, 0);

        //Add Sweets to the scene
        _.each(AntHillHacksTags, function(tag) {
            makeSweets(tag);
            console.log(tag);
        });
        

	var markerTexture = new THREE.ImageUtils.loadTexture('images/panoMarker.png');
	pano = new THREE.Mesh(new THREE.SphereGeometry(1000,50,50), new THREE.MeshBasicMaterial({side:THREE.DoubleSide, map:panos[0]}));
	pano.geometry.applyMatrix( new THREE.Matrix4().makeScale( -1, 1, 1 ) );
	
	pano.position.set(100000,0,0);
	scene.add(pano);
        for( var i=0; i<marker.length;i++)
	{
			var temp = markers[marker[i]];
			console.log(temp);
	 markerMesh[i] = new THREE.Mesh(new THREE.PlaneBufferGeometry(35,35),new THREE.MeshBasicMaterial ({map:markerTexture, transparent:true, opacity:0.9}) );
	 markerMesh[i].position.set(temp[0],temp[1],temp[2]);
	 scene.add(markerMesh[i]);
    }
   
    //dom events
    domEvents.addEventListener(
               markerMesh[0], 'dblclick',
                function(event) {
			
                    pano.material.map = panos[0];
		    pano.material.needsUpdate = true;
		    pano.position.x = camera.position.x;
		    pano.position.y = camera.position.y;
		    pano.position.z = camera.position.z;
		     panoFlag = true;
		     pano.visible = true;
		     idol_mesh.visible= false;
		     terrain_map.visible= false;
		     drone_mesh.visible= false;
		    document.getElementById('panoButton').style.display = 'block';
		    document.getElementById('nav-bar').style.display = 'none';
                }, false);

    domEvents.addEventListener(
               markerMesh[1], 'dblclick',
                function(event) {
			
                    pano.material.map = panos[1];
		    pano.material.needsUpdate = true;
		    pano.position.x = camera.position.x;
		    pano.position.y = camera.position.y;
		    pano.position.z = camera.position.z;
		     panoFlag = true;
		     pano.visible = true;
		     idol_mesh.visible= false;
		     terrain_map.visible= false;
		     drone_mesh.visible= false;
		    document.getElementById('panoButton').style.display = 'block';
		    document.getElementById('nav-bar').style.display = 'none';
                }, false);

    domEvents.addEventListener(
               markerMesh[2], 'dblclick',
                function(event) {
			
                    pano.material.map = panos[2];
		    pano.material.needsUpdate = true;
		    pano.position.x = camera.position.x;
		    pano.position.y = camera.position.y;
		    pano.position.z = camera.position.z;
		     panoFlag = true;
		     pano.visible = true;
		     idol_mesh.visible= false;
		     terrain_map.visible= false;
		     drone_mesh.visible= false;
		    document.getElementById('panoButton').style.display = 'block';
		    document.getElementById('nav-bar').style.display = 'none';
                }, false);
    domEvents.addEventListener(
               markerMesh[3], 'dblclick',
                function(event) {
			
                    pano.material.map = panos[3];
		    pano.material.needsUpdate = true;
		    pano.position.x = camera.position.x;
		    pano.position.y = camera.position.y;
		    pano.position.z = camera.position.z;
		     panoFlag = true;
		     pano.visible = true;
		     idol_mesh.visible= false;
		     terrain_map.visible= false;
		     drone_mesh.visible= false;
		    document.getElementById('panoButton').style.display = 'block';
		    document.getElementById('nav-bar').style.display = 'none';
                }, false);
	
    };	
	
    </script>

    <!-- Make Sweets Function -->
    <script>
    function makeSweets(x) {
        //generates a canvas texture with sweet data, textures onto mesh;
        //using window[] to declare global variables. find more efficient way.
        filteredsweet = swts.filterByTag(x);
       
        window[x + 'Count'] = 0;
        var temps = [];
        var who = [],
            what = [],
            where = [],
            id = [],
            created = [],
            title = [],
            tags = [],
            comment = [];
        window[x + 'ID'] = [];
        window[x + 'Canvas'] = [];
        window[x + 'Context'] = [];
        window['sweet' + x] = [];
        window[x + 'Texture'] = [];
        window[x + 'Mat'] = [];
        window[x + 'Geo'] = [];
        window[x + 'Length'] = filteredsweet.length;
        window[x + 'Url'] = [];
        window[x + 'Linkify'] = [];
        window[x + 'WebView'] = [];


        for (var i = 0; i < filteredsweet.length; i++) {
            var swt = filteredsweet[i].toJSON();
            //console.log(swt);
            window[x + 'ID'][i] = swt.id;

            who[i] = swt.who;
            what[i] = swt.what;
            if (!("title" in swt.how)) {
                title[i] = '';
            } else {
                title[i] = swt.how.title;
            }

            if (!("comment" in swt.how)) {
                comment[i] = '';
            } else {
                comment[i] = swt.how.comment;
                if (comment[i].length >= 30) {
                    var commentsubstring = comment[i].substring(0, 30) + '...';
                    comment[i] = commentsubstring;

                }
            }

            if (!("tags" in swt.how)) {
                tags[i] = '';
            } else {

                tags[i] = '';
                for (var l = 0; l < swt.how.tags.length; l++) {

                    tags[i] += '#' + swt.how.tags[l] + ' ';
                }
                

            }


            // create canvas for sweets
            window[x + 'Canvas'][i] = document.createElement('canvas');
            window[x + 'Canvas'][i].width = 256;
            window[x + 'Canvas'][i].height = 128;
            window[x + 'Context'][i] = window[x + 'Canvas'][i].getContext('2d');
            var temp = new Image();
            temp.onload = (function(i) {
                return function() {

                    window[x + 'Context'][i].drawImage(temp, 0, 0, 256, 128);
                    window[x + 'Context'][i].font = 'Regular 10px Helvetica';
                    window[x + 'Context'][i].fillStyle = "#000000";
                    window[x + 'Context'][i].fillText('~' + who[i], 200, 50);
                    //window[x+'Context'][i].fillText(what[i], 130, 30);
                    window[x + 'Context'][i].fillText(tags[i], 20, 110);
                    window[x + 'Context'][i].font = 'Regular 7px Helvetica';
                    window[x + 'Context'][i].fillText(comment[i], 80, 30);
                    window[x + 'Context'][i].font = 'Bold 10px Helvetica';
                    //window[x+'Context'][i].fillText(title[i], 20, 64);

                }
            })(i);
            temp.src = 'images/template3.png';
            window[x + 'Texture'][i] = new THREE.Texture(window[x + 'Canvas'][i]);
            window[x + 'Texture'][i].needsUpdate = true;
            window[x + 'Geo'][i] = new THREE.BoxGeometry(50, 25, 1);
            window[x + 'Mat'][i] = new THREE.MeshBasicMaterial({
                map: window[x + 'Texture'][i],
                transparent: true,
                opacity: 1
            });
            window['sweet' + x][i] = new THREE.Mesh(window[x + 'Geo'][i], window[x + 'Mat'][i]);
            scene.add(window['sweet' + x][i]);
            //window[x+'Url'][i] = 'https://thestore.swtr.in/sweets/'+window[x+'ID'][i]
            window[x + 'Linkify'][i] = THREEx.Linkify(domEvents, window['sweet' + x][i], true)

            // x is postion string eg: Anterras, Halekote
            window['sweet' + x][i].position.set(AntHill[x][0], AntHill[x][1], AntHill[x][2] + window[x + 'Count']);
            console.log((AntHill[x][0], AntHill[x][1], AntHill[x][2] + window[x + 'Count']));
            window['sweet' + x][i].name = x + i;
            window[x + 'Count'] += 2;
            domEvents.addEventListener(
                window['sweet' + x][i], 'dblclick',
                function(event) {
                    window[x + 'WebView'] = new swtsView({
                        collection: swts.filterByTag(x),
                        id: swt.id
                    });
                }, false);
        }
    };
    </script>

    <!-- Show Sweet Function -->
    <script>
    function showSweet(name, x, y, z) {
        console.log(window[name + 'Length']);
        window[name + 'ShowTween'] = [];
        for (i = 0; i < window[name + 'Length']; i++) {
            //console.log(window['sweet'+name][i].position);
            window[name + 'ShowTween'][i] = new TWEEN.Tween(window['sweet' + name][i].position).to({
                x: Math.random() * (x + 100 - (x - 100)) + (x - 100),
                y: Math.random() * (y + 100 - (y - 100)) + (y - 100),
                z: Math.random() * (z + 100 - (z - 100)) + (z - 100)
            }, 5000)

            .easing(TWEEN.Easing.Linear.None)
                .start();
        }

        sweetFlag = true;
       
    }
    </script>

    <!-- Hide Sweet Function -->
    <script>
    function hideSweet(name, x, y, z) {
        //console.log('hiding');
        window[name + 'HideTween'] = [];
        var j = 0;
        for (i = 0; i < window[name + 'Length']; i++) {
            //console.log("hiding forloop");

            //console.log(window['sweet'+name][i].position);
            window[name + 'HideTween'][i] = new TWEEN.Tween(window['sweet' + name][i].position).to({
                x: x,
                y: y,
                z: z + j
            }, 5000)

            .easing(TWEEN.Easing.Linear.None)
                .start();
            j += 2;
        }
        j = 0;
        sweetFlag = false;
        
    }
    </script>


    <!-- Other Functions -->
    <script>
	
    //handle window resizing
    function onWindowResize() {

        camera.aspect = window.innerWidth / window.innerHeight;
        camera.updateProjectionMatrix();
        renderer.setSize(window.innerWidth, window.innerHeight);

    };

    function makeRay(event) {

        raycaster2 = new THREE.Raycaster(controls.getObject().position, controls.getDirection(v3), 0, 1000);
        return raycaster2;
    };

    //Keyboard functions - currently not enabled
    function onKeyDown(event) {
        var value = 0.01,
            value2 = 1;
        switch (event.keyCode) {
            //add navigation code here
            case 38: // up
            case 87: // w
                moveForward = true;
                break;

            case 37: // left
            case 65: // a
                moveLeft = true;
                break;

            case 40: // down
            case 83: // s
                moveBackward = true;
                break;

            case 39: // right
            case 68: // d
                moveRight = true;
                break;
            case 81: //q
                moveUp = true;
                break;

            case 69: //e
                moveDown = true;
                break;
            case 32: //space
                if (sweetFlag == false) {
                    //showSweet('Anterras',6800,-800.5,250);
                    _.each(AntHillHacksTags, function(t) {
                        var p = AntHill[t];
                        showSweet(t, p[0], p[1], p[2]);
                    });
                } else {
                    //hideSweet('Anterras',6800,-800.5,350);
                    _.each(AntHillHacksTags, function(t) {
                        var p = AntHill[t];
                        hideSweet(t, p[0], p[1], p[2] - 10);
                    })
                }
        }

    };

    function onDocumentMouseDown(event) {
        //might not be required
        event.preventDefault();

        mouse.x = (event.clientX / renderer.domElement.width) * 2 - 1;
        mouse.y = -(event.clientY / renderer.domElement.height) * 2 + 1;



        var intersected;
        var ray = makeRay(event);
        if (ray.intersectObjects(scene.children).length > 0) {
            intersected = ray.intersectObjects(scene.children);
            //console.log(intersected);
            for (i = 0; i < intersected.length; i++) {
                console.log(intersected[i]);
                mClick++;
                console.log(mClick);
            }
        }
    }
    //to limit zooming
    function onDocumentMouseWheel(event) {

        // WebKit
        // console.log(this.cam.fov);
        if (camera.fov > 7.79 && camera.fov < 80) {
            if (event.wheelDeltaY) {


                camera.fov -= event.wheelDeltaY * 0.005;

                // Opera / Explorer 9

            } else if (event.wheelDelta) {

                camera.fov -= event.wheelDelta * 0.005;

                // Firefox

            } else if (event.detail) {

                camera.fov -= event.detail * 0.05;

            }
        } else {
            camera.fov = 44;
        }

        camera.updateProjectionMatrix();

    }

    //Sweet comment clouds animation when spacebar is pressed
    function animate() {
        
        requestAnimationFrame(animate);
        render();
       
        TWEEN.update();
        for (i = 0; i < AntHillHacksTags.length; i++) {
            //console.log(window[AntHillHacksTags[i]+'Length']);
            for (k = 0; k < window[AntHillHacksTags[i] + 'Length']; k++) {
                //console.log("anthill");
                //console.log(window[AntHillHacksTags[i]+'Length']);
                window['sweet' + AntHillHacksTags[i]][k].lookAt(camera.position);
                window[AntHillHacksTags[i] + 'Texture'][k].needsUpdate = true;
            }
        }
	for(j=0; j<marker.length;j++)
	{
		markerMesh[j].lookAt(camera.position);
	}
	//marker.lookAt(camera.position);
       // sweetYoga[0].lookAt(camera.position);
        //sweetYoga[0].lookAt.needsUpdate = true;
        /*
        for(var i=0; i<MaharashtraLength; i++)
        {
            sweetMaharashtra[i].lookAt(camera.position);
            MaharashtraTexture[i].needsUpdate = true;
        };
        */
    }

    function render() {

        renderer.setClearColor(0x333377);
        renderer.render(scene, camera);

    }
    </script>
</body>
